package cn.iocoder.yudao.module.ecw.service.api;

import cn.iocoder.yudao.module.ecw.api.bank.BankApi;
import cn.iocoder.yudao.module.ecw.api.bank.dto.BankAccountDTO;
import cn.iocoder.yudao.module.ecw.convert.bankAccount.BankAccountConvert;
import cn.iocoder.yudao.module.ecw.dal.dataobject.bankAccount.BankAccountDO;
import cn.iocoder.yudao.module.ecw.dal.mysql.bankAccount.BankAccountMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class BankApiImpl implements BankApi {
    @Resource
    private BankAccountMapper bankAccountMapper;

    @Override
    public BankAccountDTO getBankAccountByAccountNo(String baAccountNum) {
        List<BankAccountDO> bankAccountDO = bankAccountMapper.selectList("ba_account_num", baAccountNum);
        if (bankAccountDO != null && !bankAccountDO.isEmpty()) {
            return BankAccountConvert.INSTANCE.convertDTO(bankAccountDO.get(0));
        }
        return null;
    }

    @Override
    public BankAccountDTO getBankAccountByAccountId(Long id) {
        BankAccountDO bankAccountDO = bankAccountMapper.selectById(id);
        return BankAccountConvert.INSTANCE.convertDTO(bankAccountDO);
    }

    @Override
    public void updateBankAccountBalance(BankAccountDTO bankAccountDTO, boolean isAdd) {
        List<BankAccountDO> bankAccountDOS = bankAccountMapper.selectList(Wrappers.lambdaQuery(BankAccountDO.class)
                .eq(BankAccountDO::getBaAccountName, bankAccountDTO.getBaAccountName())
                .eq(BankAccountDO::getBaAccountNum, bankAccountDTO.getBaAccountNum())
                .eq(BankAccountDO::getBaBankName, bankAccountDTO.getBaBankName()));
        if (bankAccountDOS != null && !bankAccountDOS.isEmpty()) {
            BankAccountDO bankAccountDO = bankAccountDOS.get(0);
            if (isAdd) {
                bankAccountDO.setBaBalance(bankAccountDO.getBaBalance().add(bankAccountDTO.getBaBalance()));
            } else {
                bankAccountDO.setBaBalance(bankAccountDO.getBaBalance().subtract(bankAccountDTO.getBaBalance()));
            }
            bankAccountMapper.updateById(bankAccountDO);
        }
    }
}
